package pro.gravit.launchserver.socket.response.auth;

import io.netty.channel.ChannelHandlerContext;
import pro.gravit.launcher.events.request.ErrorRequestEvent;
import pro.gravit.launcher.events.request.ProfilesRequestEvent;
import pro.gravit.launcher.profiles.ClientProfile;
import pro.gravit.launchserver.auth.protect.interfaces.ProfilesProtectHandler;
import pro.gravit.launchserver.socket.Client;
import pro.gravit.launchserver.socket.response.SimpleResponse;

import java.util.ArrayList;
import java.util.List;

public class ProfilesResponse extends SimpleResponse {
    @Override
    public String getType() {
        return "profiles";
    }

    @Override
    public void execute(ChannelHandlerContext ctx, Client client) {
        if (server.config.protectHandler instanceof ProfilesProtectHandler && !((ProfilesProtectHandler) server.config.protectHandler).canGetProfiles(client)) {
            sendError("Access denied");
            return;
        }

        List<ClientProfile> profileList;
        List<ClientProfile> serverProfiles = server.getProfiles();
        if (server.config.protectHandler instanceof ProfilesProtectHandler)
        {
            ProfilesProtectHandler protectHandler = (ProfilesProtectHandler) server.config.protectHandler;
            profileList = new ArrayList<>(4);
            for(ClientProfile profile : serverProfiles)
            {
                if(protectHandler.canGetProfile(profile, client))
                {
                    profileList.add(profile);
                }
            }
        }
        else
        {
            profileList = serverProfiles;
        }
        sendResult(new ProfilesRequestEvent(profileList));
    }
}
